<template>
	<xn-form-container
		:title="formData.id ? (disabled ? '查看采集人员信息维护' : '编辑监测采集人员信息维护') : '增加监测采集人员信息维护'"
		:width="700"
		:visible="visible"
		:destroy-on-close="true"
		@close="onClose"
	>
		<a-form ref="formRef" :model="formData" :rules="formRules" layout="vertical">
			<a-form-item label="人员姓名：" name="name">
				<a-input v-model:value="formData.name" :disabled="disabled" placeholder="请输入人员姓名" allow-clear />
			</a-form-item>
			<a-form-item label="手机号：" name="phone">
				<a-input v-model:value="formData.phone" :disabled="disabled" placeholder="请输入手机号" allow-clear />
			</a-form-item>
			<a-form-item label="联系地址：" name="address">
				<a-input v-model:value="formData.address" :disabled="disabled" placeholder="请输入联系地址" allow-clear />
			</a-form-item>
			<a-form-item label="账号：" name="account">
				<a-input v-model:value="formData.account" :disabled="disabled" placeholder="请输入账号" allow-clear />
			</a-form-item>
			<a-form-item label="密码：" name="password">
				<a-input v-model:value="formData.password" :disabled="disabled" placeholder="请输入密码" allow-clear />
			</a-form-item>
		</a-form>
		<template #footer>
			<a-button style="margin-right: 8px" @click="onClose">关闭</a-button>
			<a-button v-if="disabled !== true" type="primary" @click="onSubmit" :loading="submitLoading">保存</a-button>
		</template>
	</xn-form-container>
</template>

<script setup name="userCollectForm">
	import { cloneDeep } from 'lodash-es'
	import { required } from '@/utils/formRules'
	import userCollectApi from '@/api/basic.info/userCollectApi'
	// 抽屉状态
	const visible = ref(false)
	const emit = defineEmits({ successful: null })
	const formRef = ref()
	// 表单数据
	const formData = ref({})
	const submitLoading = ref(false)
	const disabled = ref(false)

	// 打开抽屉
	const onOpen = (record, flag) => {
		visible.value = true
		if (record) {
			let recordData = cloneDeep(record)
			formData.value = Object.assign({}, recordData)
		}
		if (flag) {
			disabled.value = flag
		} else {
			disabled.value = false
		}
	}
	// 关闭抽屉
	const onClose = () => {
		formRef.value.resetFields()
		formData.value = {}
		visible.value = false
	}
	// 默认要校验的
	const formRules = {}
	// 验证并提交数据
	const onSubmit = () => {
		formRef.value.validate().then(() => {
			submitLoading.value = true
			const formDataParam = cloneDeep(formData.value)
			userCollectApi
				.userCollectSubmitForm(formDataParam, formDataParam.id)
				.then(() => {
					onClose()
					emit('successful')
				})
				.finally(() => {
					submitLoading.value = false
				})
		})
	}
	// 抛出函数
	defineExpose({
		onOpen
	})
</script>
